/*
 *   (c) 2003 by Eduardo Enrique Gonzlez Rodrguez
 *   Distributed under GPL, see license.txt file in the package
 *
 *   Header file of dec_dyn.c
 */

#include "defs.h"


/*
 *   Create a "virtual block" of symbols. Needed to start decoding a
 * stream of symbols.
 */

void
dec_dyn_block0(word *freq, symbol *block, int block_size, word *counter,
	       word *last_counter);

/*
 *   Decodes a block of data. The frequencies used during the decoding
 * process are guessed dynamically during the decompression process.
 */

void
dec_dyn_pic(stream *input, dword *input_size, word *counter,
	    word *last_counter, word *freq, unsigned char *output,
	    dword *output_size);

/*
 *   Modification of the dec_dyn_pic() function to use arithmetic coding
 * instead of phasing in codes in the feedback stage.
 */

void
dec_dyn_ac(stream *input, dword *input_ptr, word *counter,
	   word *last_counter, word *freq, unsigned char *output,
	   dword *output_size);

/*
 *   Modification of the dec_dyn_ac() function to be used in the first
 * block of symbols.
 */

void
dec_dyn1st(stream *input, dword *input_ptr, word *counter,
	   word *last_counter, word *freq, unsigned char *output,
	   dword *output_size);

