/*
 *   (c) 2003 by Eduardo Enrique Gonzlez Rodrguez
 *   Distributed under GPL, see license.txt file in the package
 *
 *   Header file of enc_dyn.c
 */

#include "defs.h"



/*
 *   Counts symbols in the input and fills other data structures used
 * during compression.
 */

void
count_symbols(symbol *input, int input_size, word *freq, word *old_freq,
	      word *address, word *address_index);

/*
 *   Creates a virtual data block 0 in the encoding stream. All blocks need
 * a preceding one to be processed, and this one will be used to compress
 * the first block of the stream.
 */

void
enc_dyn_block0(word *input_freq, symbol *block, int block_size, word *freq,
	       word *address, word *address_index);

/* 
 *   Encodes a block of information, making a dynamic estimation of the
 * frequency distribution of all of the symbols.
 */

void
enc_dyn_pic(symbol *ibuffer1, symbol *ibuffer2, int input_size,
	    word *freq1, word *freq2,
	    word *address_index1, word *address_index2,
	    word *address1, word *address2,
	    stream *output, dword *output_start);

/*
 *   Modification of the previous function to feedback information using
 * arithmetic coding instead of phasing in codes.
 */

void
enc_dyn_ac(symbol *ibuffer1, symbol *ibuffer2, int input_size,
	   word *freq1, word *freq2,
	   word *address_index1, word *address_index2,
	   word *address1, word *address2,
	   stream *output, dword *output_idx);

/*
 *   Modification of the previous function to work without any previous
 * block processed before. It has to be called to encode the very first
 * block of symbols of any input stream.
 */

void
enc_dyn1st(symbol *ibuffer, int input_size, word *freq,
	    word *address_index, word *address,
	    stream *output, dword *output_idx);


