/*
 *   (c) 2003 by Eduardo Enrique Gonzlez Rodrguez
 *   Distributed under GPL, see license.txt file in the package
 *
 *   Header file of enc_stat.c
 */

#include "defs.h"

/* 
 *   Encodes a block of information, making a dynamic estimation of the
 * frequency distribution of all of the symbols.
 */

void
enc_static_pic(symbol *input, int input_size, stream *output, dword *out_idx,
	       word *hash);

/* 
 *   This is an implementation of rf-coding using arithmetic coding of
 * numbers in a range instead of phasing in codes. It gives higher
 * compression at the cost of processing power.
 */

void
enc_static_ac(symbol *input, int input_size, stream *output, dword *out_idx);

