/*
 *   (c) 2003 by Eduardo Enrique Gonzlez Rodrguez
 *   Distributed under GPL, see license.txt file in the package
 *
 *  Header file for freqs.c
 *
 *  Common frequency manipulation functions.
 */

#include "defs.h"

/* Init the bits_for_range array */

void
init_bits_for_range(void);

/* Writes frequency table to the output stream */
void
write_freqs(stream *output, dword *index, word *freq1, word *freq2,
	    word max_tot_freq1, word max_tot_freq2);

/* Reads frequency table from the input stream */
void
read_freqs(stream *input, dword *index, word *freq1, word *freq2,
	   word *sum1, word *sum2, word max_tot_freq1, word max_tot_freq2);

/*
 *   Scales freq1 and freq2 to fit to their respective CODE_RANGE1 and
 * CODE_RANGE2. Also completes both frequency tables and assigns a code to
 * the low frequency symbols.
 */

void
adjust_freqs(word *freq1, word *freq2, word total1, int *least_freq);

/* Scales frequencies in a frequency array to fit the sliding window. */
void
scale_freq(word *freq, word total);

/*
 *   Balance frequencies, iteratively moving values between adjacent ones
 * when it increases compression.
 */

void
balance_freq(word *freq, word *real_freq);

