/*
 *   (c) 2003 by Eduardo Enrique Gonzlez Rodrguez
 *   Distributed under GPL, see license.txt file in the package
 *
 *   Hash functions for rf-coding.
 */

#include <stdlib.h> /* malloc() */
#include "defs.h"

#define RAND_A 231
#define RAND_C 4234
#define RAND_M 90001

static int
xrand(int x)
{
	x = ((RAND_A * x) + RAND_C) % RAND_M;
	return(x);
}

/*
 *   Returns a table filled with a hash function in the range and the
 * domain of interval [0, size).
 */

word*
make_hash(int size)
{
	int i;
	int x;
	int n1;
	int n2;
	word *func;
	word *random;

	func = (word*)malloc(size * sizeof(word));
	random = (word*)malloc(size * sizeof(word));
	for (i = 0; i < (size - 1); i++)
		random[i] = i + 1;
	n1 = 0;
	for (i = size-1; i > 0; i--) {
		x = xrand(n1) % i;
		n2 = random[x]; /* Gets next entry */
		random[x] = random[i - 1];
		func[n1] = n2;
		n1 = n2;
	}
	func[n1] = 0;
	free(random);
	return(func);
}

/* Returns a table filled with the identity function. */
word*
make_identity(int size)
{
	word *func;
	int i;

	func = (word*)malloc(size * sizeof(word));
	for (i = 0; i < size; i++)
		func[i] = i;
	return(func);
}


